﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridDemo
{
    public class ViewModel: NotificationObject
    {
        ObservableCollection<Model> orderCollection;
        public ObservableCollection<Model> OrderInfoCollection
        {
            get { return orderCollection; }
            set { orderCollection = value; }
        }

        private ObservableCollection<string> comboItems = new ObservableCollection<string>();
        //The ComboBoxColumn is being bound to this property defined and populated in the ViewModel, every other binding is to the Model itself.
        //Further comments in the model file...
        public ObservableCollection<string> ComboItems
        {
            get { return comboItems; }
            set { comboItems = value; }
        }

        private object selecteditems;

        public object SelectedItem
        {
            get { return selecteditems; }
            set { this.selecteditems = value;
                RaisePropertyChanged("SelectedItem");
            }
        }

        public ViewModel()
        {
            orderCollection = new ObservableCollection<Model>();            
            OrderInfoCollection = GenerateOrders();            
            comboItems.Add("Brandenburg-Germany");
            comboItems.Add("México D.F.-Mexico");
            comboItems.Add("Guadalajara-Mexico");
            comboItems.Add("Buenos Aires-Argentina");
            comboItems.Add("Limerick-Ireland");
            comboItems.Add("Reggio Emilia-Italy");
            comboItems.Add("Bruxelles-Belgium");
            comboItems.Add("Vancouver-Canada");
            comboItems.Add("Stuttgart-Germany-Country");
            comboItems.Add("Frankfurt a.M.-Germany-Country");
            comboItems.Add("Frankfurt a.M.-Brazil-Country");
            comboItems.Add("Rio de Janeiro-Brazil");
            comboItems.Add("Brandenburg-Germany");
            comboItems.Add("Buenos Aires-Argentina");
            comboItems.Add("Rio de Janeiro-Brazil-Country");          
        }

        public ObservableCollection<Model> GenerateOrders()
        {
            ObservableCollection<Model> orders = new ObservableCollection<Model>();
            for (int i = 1; i <= 3; i++)
            {
                //the collection added here to the constructor
                orders.Add(new Model(1001, "Maria Anders", "Germany", "ALFKI", "Brandenburg", new List<decimal> { 10000, 40000, 50000 }));
                orders.Add(new Model(1002, "Ana Trujilo", "Mexico", "ANATR", "México D.F.", new List<decimal> { 23000, 44000, 554000 } ));
                orders.Add(new Model(1003, "Antonio Moreno", "Mexico", "ANTON", "Guadalajara", new List<decimal> { 500, 4200, 50400 } ));
                orders.Add(new Model(1004, "Thomas Hardy", "Argentina", "AROUT", "Mendoza", new List<decimal> { 123, 4030, 5400 } ));
                orders.Add(new Model(1005, "Christina Berglund", "Brazil", "BERGS", "Campinas", new List<decimal> { 15500, 4040, 4400 } ));
                orders.Add(new Model(1006, "Hanna Moos", "Germany", "BLAUS", "Aachen", new List<decimal> { 189000, 49000, 556700 } ));
                orders.Add(new Model(1007, "Frédérique Citeaux", "Ireland", "BLONP", "Strasbourg", new List<decimal> { 23400, 5000, 5260 } ));
                orders.Add(new Model(1008, "Martin Sommer", "Italy", "BOLID", "Torino", new List<decimal> { 10, 400, 500 } ));
                orders.Add(new Model(1009, "Laurence Lebihan", "Belgium", "BONAP", "Charleroi", new List<decimal> { 134000, 40040, 57000 } ));
                orders.Add(new Model(1010, "Elizabeth Lincoln", "Canada", "BOTTM", "Vancouver", new List<decimal> { 102340, 402340, 502340 } ));
            }
            return orders;        
        }
    }
}
